asn1-types-0.3.0: ASN.1 types

License | BSD-style
Maintainer | Vincent Hanquez <vincent@snarc.org>
Stability | experimental
Portability | unknown
Safe Haskell | Safe-Inferred
Language | Haskell98

Data.ASN1.BitArray

Description

Synopsis

- data BitArray = BitArray Word64 ByteString
- data BitArrayOutOfBound = BitArrayOutOfBound Word64
- bitArrayLength :: BitArray -> Word64
- bitArrayGetBit :: BitArray -> Word64 -> Bool
- bitArraySetBitValue :: BitArray -> Word64 -> Bool -> BitArray
- bitArraySetBit :: BitArray -> Word64 -> BitArray
- bitArrayClearBit :: BitArray -> Word64 -> BitArray
- bitArrayGetData :: BitArray -> ByteString
- toBitArray :: ByteString -> Int -> BitArray

# Documentation

data BitArray

represent a bitarray / bitmap

the memory representation start at bit 0

Constructors

BitArray Word64 ByteString |

Instances

Eq BitArray |
Show BitArray |

data BitArrayOutOfBound

throwed in case of out of bounds in the bitarray.

Constructors

BitArrayOutOfBound Word64 |

Instances

Eq BitArrayOutOfBound |
Show BitArrayOutOfBound |
Exception BitArrayOutOfBound |
Typeable * BitArrayOutOfBound |

bitArrayLength :: BitArray -> Word64

returns the length of bits in this bitarray

bitArrayGetBit :: BitArray -> Word64 -> Bool

get the nth bits

bitArraySetBitValue :: BitArray -> Word64 -> Bool -> BitArray

set the nth bit to the value specified

bitArraySetBit :: BitArray -> Word64 -> BitArray

set the nth bits

bitArrayClearBit :: BitArray -> Word64 -> BitArray

clear the nth bits

bitArrayGetData :: BitArray -> ByteString

get padded bytestring of the bitarray

toBitArray :: ByteString -> Int -> BitArray

number of bit to skip at the end (padding)